---
title: llarp::quic::TunnelManager::ClientTunnel

---

# llarp::quic::TunnelManager::ClientTunnel





## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[~ClientTunnel](Classes/structllarp_1_1quic_1_1TunnelManager_1_1ClientTunnel.md#function-~clienttunnel)**() |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| std::unique_ptr< [Client](Classes/classllarp_1_1quic_1_1Client.md) > | **[client](Classes/structllarp_1_1quic_1_1TunnelManager_1_1ClientTunnel.md#variable-client)**  |
| [OpenCallback](Classes/classllarp_1_1quic_1_1TunnelManager.md#using-opencallback) | **[open_cb](Classes/structllarp_1_1quic_1_1TunnelManager_1_1ClientTunnel.md#variable-open-cb)**  |
| std::shared_ptr< uvw::TCPHandle > | **[tcp](Classes/structllarp_1_1quic_1_1TunnelManager_1_1ClientTunnel.md#variable-tcp)**  |
| std::unordered_set< std::shared_ptr< uvw::TCPHandle > > | **[conns](Classes/structllarp_1_1quic_1_1TunnelManager_1_1ClientTunnel.md#variable-conns)**  |
| std::queue< std::weak_ptr< uvw::TCPHandle > > | **[pending_incoming](Classes/structllarp_1_1quic_1_1TunnelManager_1_1ClientTunnel.md#variable-pending-incoming)**  |

## Public Functions Documentation

### function ~ClientTunnel

```cpp
~ClientTunnel()
```


## Public Attributes Documentation

### variable client

```cpp
std::unique_ptr< Client > client;
```


### variable open_cb

```cpp
OpenCallback open_cb;
```


### variable tcp

```cpp
std::shared_ptr< uvw::TCPHandle > tcp;
```


### variable conns

```cpp
std::unordered_set< std::shared_ptr< uvw::TCPHandle > > conns;
```


### variable pending_incoming

```cpp
std::queue< std::weak_ptr< uvw::TCPHandle > > pending_incoming;
```


-------------------------------

Updated on 2022-08-30 at 18:09:27 +0000